# CbcIntegerBranchingObject Class Reference

Simple branching object for an integer variable. More...

`#include <CbcSimpleInteger.hpp>`

Inheritance diagram for CbcIntegerBranchingObject:
[legend]
Collaboration diagram for CbcIntegerBranchingObject:
[legend]

List of all members.

## Public Member Functions
| CbcIntegerBranchingObject ()
| Default constructor.
| CbcIntegerBranchingObject (CbcModel *model, int variable, int way, double value)
| Create a standard floor/ceiling branch object.
| CbcIntegerBranchingObject (CbcModel *model, int variable, int way, double lowerValue, double upperValue)
| Create a degenerate branch object.
| CbcIntegerBranchingObject (const CbcIntegerBranchingObject &)
| Copy constructor.
CbcIntegerBranchingObject & | operator= (const CbcIntegerBranchingObject &rhs)
| Assignment operator.
virtual CbcBranchingObject * | clone () const
| Clone.
virtual | ~CbcIntegerBranchingObject ()
| Destructor.
void | fillPart (int variable, int way, double value)
| Does part of constructor.
virtual double | branch ()
| Sets the bounds for the variable according to the current arm of the branch and advances the object state to the next arm.
virtual void | fix (OsiSolverInterface *solver, double *lower, double *upper, int branchState) const
| Update bounds in solver as in 'branch' and update given bounds.
virtual bool | tighten (OsiSolverInterface *)
| Change (tighten) bounds in object to reflect bounds in solver.
virtual void | print ()
| Print something about branch - only if log level high.
const double * | downBounds () const
| Lower and upper bounds for down branch.
const double * | upBounds () const
| Lower and upper bounds for up branch.
void | setDownBounds (const double bounds[2])
| Set lower and upper bounds for down branch.
void | setUpBounds (const double bounds[2])
| Set lower and upper bounds for up branch.
virtual CbcBranchObjType | type () const
| Return the type (an integer identifier) of `this`.
virtual CbcRangeCompare | compareBranchingObject (const CbcBranchingObject *brObj, const bool replaceIfOverlap=false)
| Compare the `this` with `brObj`.
## Protected Attributes
double | down_ [2]
| Lower [0] and upper [1] bounds for the down arm (way_ = -1).
double | up_ [2]
| Lower [0] and upper [1] bounds for the up arm (way_ = 1).

## Detailed Description

Simple branching object for an integer variable.

This object can specify a two-way branch on an integer variable. For each arm of the branch, the upper and lower bounds on the variable can be independently specified.

Variable_ holds the index of the integer variable in the integerVariable_ array of the model.

Definition at line 23 of file CbcSimpleInteger.hpp.

## Constructor & Destructor Documentation

CbcIntegerBranchingObject::CbcIntegerBranchingObject | ( |  | ) |

Default constructor.

CbcIntegerBranchingObject::CbcIntegerBranchingObject | ( | CbcModel * | model,
|  | int | variable,
|  | int | way,
|  | double | value |
| ) |  |  |

Create a standard floor/ceiling branch object.

Specifies a simple two-way branch. Let `value` = x*. One arm of the branch will be lb <= x <= floor(x*), the other ceil(x*) <= x <= ub. Specify way = -1 to set the object state to perform the down arm first, way = 1 for the up arm.

CbcIntegerBranchingObject::CbcIntegerBranchingObject | ( | CbcModel * | model,
|  | int | variable,
|  | int | way,
|  | double | lowerValue,
|  | double | upperValue |
| ) |  |  |

Create a degenerate branch object.

Specifies a `one-way branch'. Calling branch() for this object will always result in lowerValue <= x <= upperValue. Used to fix a variable when lowerValue = upperValue.

CbcIntegerBranchingObject::CbcIntegerBranchingObject | ( | const CbcIntegerBranchingObject & |  | ) |

Copy constructor.

virtual CbcIntegerBranchingObject::~CbcIntegerBranchingObject | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

CbcIntegerBranchingObject& CbcIntegerBranchingObject::operator= | ( | const CbcIntegerBranchingObject & | rhs | ) |

Assignment operator.

Reimplemented from CbcBranchingObject.

Reimplemented in CbcDynamicPseudoCostBranchingObject, and CbcIntegerPseudoCostBranchingObject.

virtual CbcBranchingObject* CbcIntegerBranchingObject::clone | ( |  | ) | const`[virtual]`

Clone.

Implements CbcBranchingObject.

Reimplemented in CbcDynamicPseudoCostBranchingObject, and CbcIntegerPseudoCostBranchingObject.

void CbcIntegerBranchingObject::fillPart | ( | int | variable,
|  | int | way,
|  | double | value |
| ) |  |  |

Does part of constructor.

virtual double CbcIntegerBranchingObject::branch | ( |  | ) | `[virtual]`

Sets the bounds for the variable according to the current arm of the branch and advances the object state to the next arm.

Returns change in guessed objective on next branch

Implements CbcBranchingObject.

Reimplemented in CbcDynamicPseudoCostBranchingObject, and CbcIntegerPseudoCostBranchingObject.

virtual void CbcIntegerBranchingObject::fix | ( | OsiSolverInterface * | solver,
|  | double * | lower,
|  | double * | upper,
|  | int | branchState |
| ) |  |  | const`[virtual]`

Update bounds in solver as in 'branch' and update given bounds.

branchState is -1 for 'down' +1 for 'up'

Reimplemented from CbcBranchingObject.

virtual bool CbcIntegerBranchingObject::tighten | ( | OsiSolverInterface * |  | ) | `[virtual]`

Change (tighten) bounds in object to reflect bounds in solver.

Return true if now fixed

Reimplemented from CbcBranchingObject.

virtual void CbcIntegerBranchingObject::print | ( |  | ) | `[virtual]`

Print something about branch - only if log level high.

const double* CbcIntegerBranchingObject::downBounds | ( |  | ) | const`[inline]`

Lower and upper bounds for down branch.

Definition at line 93 of file CbcSimpleInteger.hpp.

const double* CbcIntegerBranchingObject::upBounds | ( |  | ) | const`[inline]`

Lower and upper bounds for up branch.

Definition at line 97 of file CbcSimpleInteger.hpp.

void CbcIntegerBranchingObject::setDownBounds | ( | const double | bounds[2] | ) | `[inline]`

Set lower and upper bounds for down branch.

Definition at line 101 of file CbcSimpleInteger.hpp.

void CbcIntegerBranchingObject::setUpBounds | ( | const double | bounds[2] | ) | `[inline]`

Set lower and upper bounds for up branch.

Definition at line 105 of file CbcSimpleInteger.hpp.

virtual CbcBranchObjType CbcIntegerBranchingObject::type | ( |  | ) | const`[inline, virtual]`

Return the type (an integer identifier) of `this`.

Implements CbcBranchingObject.

Reimplemented in CbcDynamicPseudoCostBranchingObject, and CbcIntegerPseudoCostBranchingObject.

Definition at line 133 of file CbcSimpleInteger.hpp.

virtual CbcRangeCompare CbcIntegerBranchingObject::compareBranchingObject | ( | const CbcBranchingObject * | brObj,
|  | const bool | replaceIfOverlap = `false` |
| ) |  |  | `[virtual]`

Compare the `this` with `brObj`.

`this` and `brObj` must be os the same type and must have the same original object, but they may have different feasible regions. Return the appropriate CbcRangeCompare value (first argument being the sub/superset if that's the case). In case of overlap (and if `replaceIfOverlap` is true) replace the current branching object with one whose feasible region is the overlap.

Reimplemented in CbcIntegerPseudoCostBranchingObject.

## Member Data Documentation

double CbcIntegerBranchingObject::down_[2]`[protected]`

Lower [0] and upper [1] bounds for the down arm (way_ = -1).

Definition at line 150 of file CbcSimpleInteger.hpp.

double CbcIntegerBranchingObject::up_[2]`[protected]`

Lower [0] and upper [1] bounds for the up arm (way_ = 1).

Definition at line 152 of file CbcSimpleInteger.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Cbc-2.8.0/Cbc/src/CbcSimpleInteger.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines